%define moduledir %(pkg-config xorg-server --variable=moduledir )
%define driverdir	%{moduledir}/drivers

%define batchbuffer_version 2.2.0-219-gc9676d0

Summary:   Xorg X11 Intel video driver(s)
Name:      xorg-x11-drv-i810
Version:   2.2.1
Release:   24%{?dist}
URL:       http://www.x.org
License:   MIT
Group:     User Interface/X Hardware Support
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Source0:   http://xorg.freedesktop.org/archive/individual/driver/xf86-video-intel-%{version}.tar.bz2 

# Update git snapshot by saying make dist distdir=$(git-describe) from
# the intel-batchbuffer branch.
Source1:   xf86-video-intel-%{batchbuffer_version}.tar.bz2 
Source2:   i810.xinf
Source3:   intel-stub.c

Patch1: intel-update.patch
Patch2: intel-2.1.1-fix-vt-switch.patch
Patch3: intel-2.1.1-fix-xv-reset.patch
Patch4: intel-2.1.1-fix-xv-compiz.patch
Patch8: intel-2.1.1-disable-ttm.patch

# EXA on 965 without DRI is broken - fix for now so installer can run
#Patch9: intel-2.2.0-xaadefault.patch

# Framebuffer compression causes artifacts, display blanking
# https://bugs.freedesktop.org/show_bug.cgi?id=13326
Patch11: intel-2.2.1-disable-fbc.patch

# Fix XAA overlay video when Composite is enabled
Patch12: intel-2.2.1-xaa-xv.patch

Patch100: intel-master.patch
Patch101: intel-batchbuffer.patch
Patch103: intel-disable-stepping.patch
Patch104: intel-fix-modeset-vt-switch.patch

ExclusiveArch: %{ix86} x86_64 ia64

BuildRequires: autoconf automake libtool
BuildRequires: xorg-x11-server-devel >= 1.4.99.1
BuildRequires: libXvMC-devel
BuildRequires: mesa-libGL-devel >= 6.5-9
BuildRequires: libdrm-devel >= 2.0-1

Requires:  hwdata
Requires:  xorg-x11-server-Xorg >= 1.4.99.1

Conflicts:  kudzu < 1.2.42-1

%description 
X.Org X11 Intel video driver.

%package devel
Summary:   Xorg X11 Intel video driver XvMC development package
Group:     Development/System
Requires:  %{name} = %{version}-%{release}
Provides:  xorg-x11-drv-intel-devel = %{version}-%{release}

%description devel
X.Org X11 Intel video driver XvMC development package.

%prep
%setup -q -c %{name}-%{version} -a1

cd xf86-video-intel-%{version}
# XXX rebase me plz
%patch1 -p1 -b .2.3
#patch2 -p1 -b .vtswitch
%patch3 -p1 -b .xvfix
#patch4 -p1 -b .xv-compiz
%patch8 -p1 -b .disablettm
%patch11 -p1 -b .fbc
%patch12 -p1 -b .xaa-xv
%patch100 -p1 -b .intel-master

cd ../xf86-video-intel-%{batchbuffer_version}
%patch101 -p1 -b .intel-batchbuffer
%patch103 -p1 -b .intel-stepping
%patch104 -p1 -b .intel-fix-vt-modeset
%patch11 -p1 -b .fbc
%build

cd xf86-video-intel-%{version}
aclocal; autoheader; automake -a; autoconf
%configure --disable-static --libdir=%{_libdir} --mandir=%{_mandir} --enable-dri
make

cd ../xf86-video-intel-%{batchbuffer_version}
aclocal; autoheader; automake -a; autoconf
%configure --disable-static --libdir=%{_libdir} --mandir=%{_mandir} --enable-dri
make

# Build the wrapper driver that lets us load either intel_master or
# intel_batchbuffer driver as just 'intel'

cd ..
gcc -o intel_drv.so -shared -fPIC -DPIC %{SOURCE3} \
	$RPM_OPT_FLAGS $(pkg-config --cflags --libs xorg-server)

%install
rm -rf $RPM_BUILD_ROOT

make -C xf86-video-intel-%{version} install DESTDIR=$RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT%{_libdir}/xorg/modules/drivers/intel_drv.so  $RPM_BUILD_ROOT%{_libdir}/xorg/modules/drivers/intel_master_drv.so

make -C xf86-video-intel-%{batchbuffer_version} install DESTDIR=$RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT%{_libdir}/xorg/modules/drivers/intel_drv.so  $RPM_BUILD_ROOT%{_libdir}/xorg/modules/drivers/intel_batchbuffer_drv.so

mkdir -p $RPM_BUILD_ROOT%{driverdir}
install -m 0755 %{_builddir}/%{name}-%{version}/intel_drv.so \
	$RPM_BUILD_ROOT%{driverdir}

mkdir -p $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases/


find $RPM_BUILD_ROOT -regex ".*\.la$" | xargs rm -f --

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{driverdir}/i810_drv.so
%{driverdir}/intel_drv.so
%{driverdir}/intel_master_drv.so
%{driverdir}/intel_batchbuffer_drv.so
%{driverdir}/ch7xxx.so
%{driverdir}/sil164.so
%{driverdir}/ch7017.so
%{driverdir}/ivch.so
%{driverdir}/tfp410.so
%{_datadir}/hwdata/videoaliases/i810.xinf
%{_libdir}/libI810XvMC.so.1
%{_libdir}/libI810XvMC.so.1.0.0
%{_libdir}/libIntelXvMC.so.1
%{_libdir}/libIntelXvMC.so.1.0.0
%{_mandir}/man4/i*

%files devel
%defattr(-,root,root,-)
%{_libdir}/libI810XvMC.so
%{_libdir}/libIntelXvMC.so

%changelog
* Tue May 06 2008 Dave Airlie <airlied@redhat.com> 2.2.1-24
- fix xinf file to include IGD

* Fri Apr 25 2008 Adam Jackson <ajax@redhat.com> 2.2.1-23
- intel-stub.c: Fix a crash when running without a config file. (#443831)

* Wed Apr 23 2008 Adam Jackson <ajax@redhat.com> 2.2.1-22
- intel-2.2.1-xaa-xv.patch: Fix Xv overlay video to work when using XAA
  and when the compositor is active. (#239125)

* Mon Apr 21 2008 Dave Airlie <airlied@redhat.com> 2.2.1-21
- include some updates to 2.3 rc, remove lots of patches
- fixes EXA to work without DRI properly

* Tue Apr  8 2008 Bill Nottingham <notting@redhat.com> - 2.2.1-20
- disable framebuffer compression by default (fdo #13326)

* Wed Apr  2 2008 Kristian Høgsberg <krh@redhat.com> - 2.2.1-19
- Rebase batchbuffer driver to pull in fix for EAGAIN handling around
  batchbuffer submit ioctl.

* Wed Apr  2 2008 Kristian Høgsberg <krh@redhat.com> - 2.2.1-18
- Tweak intel-stub.c and batchbuffer branch to read options from
  server flags section too.

* Tue Apr  1 2008 Kristian Høgsberg <krh@redhat.com> - 2.2.1-17
- Add new snapshot of the batchbuffer driver to go with the DRI2 changes.
- Add "DRI2" as a server layout options to enable batchbuffer and DRI2.

* Tue Apr 01 2008 Adam Jackson <ajax@redhat.com> 2.2.1-16
- intel-stub.c: Remember the i810 users! (#439845)

* Tue Mar 25 2008 Jeremy Katz <katzj@redhat.com> - 2.2.1-15
- Add jbarnes's backlight test patch

* Tue Mar 18 2008 Dave Airlie <airlied@redhat.com> 2.2.1-14
- make XAA default for now so installer can be run on 965 hw

* Tue Mar 18 2008 Dave Airlie <airlied@redhat.com> 2.2.1-13
- fix modesetting for normal DRI codepath

* Fri Mar 14 2008 Dave Airlie <airlied@redhat.com> 2.2.1-12
- fix modesetting vt switch to not hit the non-existant ring

* Wed Mar 12 2008 Dave Airlie <airlied@redhat.com> 2.2.1-11
- fall intel master driver back to non-TTM mode avoids compiz fail

* Mon Mar 10 2008 Dave Airlie <airlied@redhat.com> 2.2.1-10
- quirk Motion Computing M1200

* Fri Mar 07 2008 Dave Airlie <airlied@redhat.com> 2.2.1-9
- update modesetting patch to include 965 video + fix for memory
  space leak

* Fri Mar 07 2008 Dave Airlie <airlied@redhat.com> 2.2.1-8
- fixup pciaccess version check and autoconf and fallout

* Fri Mar 07 2008 Dave Airlie <airlied@redhat.com> 2.2.1-7
- re-run autoconf to build modesetting with batchbuffer

* Thu Mar 06 2008 Dave Airlie <airlied@redhat.com> 2.2.1-6
- fix modesetting to start on i965 chips

* Thu Mar 06 2008 Dave Airlie <airlied@redhat.com> 2.2.1-5
- Bump to include modesetting driver - and make stub auto pick
  batchbuffer branch if modesetting enabled

* Mon Mar  3 2008 Kristian Høgsberg <krh@redhat.com> - 2.2.1-4
- Bump intel-batchbuffer to latest snapshot, rebuild against new server ABI.

* Mon Mar 03 2008 Dave Airlie <airlied@redhat.com> 2.2.1-3
- update for new server abi

* Thu Feb 28 2008 Adam Jackson <ajax@redhat.com> 2.2.1-2
- intel-2.1.1-efi.patch: Fix SDVO I2C on Mac Mini in EFI mode.

* Wed Feb 27 2008 Kristian Høgsberg <krh@redhat.com> - 2.2.1-1
- Bump to 2.2.1, include build of the intel-batchbuffer branch.

* Wed Feb 20 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 2.2.0-4
- Autorebuild for GCC 4.3

* Wed Jan 09 2008 Adam Jackson <ajax@redhat.com> 2.2.0-3
- Rebuild for new server ABI.
- intel-2.2.0-alloca.patch: Fix use of {DE,}ALLOCATE_LOCAL.

* Mon Dec 10 2007 Dave Airlie <airlied@redhat.com> 2.2.0-2
- hook up ch7017 (bz#408471)

* Tue Nov 27 2007 Adam Jackson <ajax@redhat.com> 2.2.0-1
- xf86-video-intel 2.2.0

* Tue Nov 13 2007 Adam Jackson <ajax@redhat.com> 2.1.99-1
- xf86-video-intel 2.1.99.
- Drop the i810 driver.  Time to move on.
- Require xserver 1.4.99.1

* Wed Oct 17 2007 Dave Airlie <airlied@redhat.com> 2.1.1-7
- intel-2.1.1-fix-xv-compiz.patch - update to not crash is we can't get RAM

* Wed Oct 17 2007 Dave Airlie <airlied@redhat.com> 2.1.1-6
- intel-2.1.1-fix-xv-compiz.patch - Real dirty hack to allocate 4MB of RAM
  for textured Xv to use as an offscreen pixmap so xv actually works under
  compiz - granted it may be unusably slow but at least stuff shows up.

* Mon Oct 15 2007 Dave Airlie <airlied@redhat.com> 2.1.1-5
- intel-2.1.1-fix-vt-switch.patch - Only restore paletter regs on enabled pipes
- intel-2.1.1-fix-xv-reset.patch - Reset XV after mode switch

* Fri Oct 05 2007 Dave Airlie <airlied@redhat.com> 2.1.1-4
- intel-2.1.1-quirk-update.patch - update quirks from master

* Mon Aug 20 2007 Adam Jackson <ajax@redhat.com> 2.1.1-3
- i810.xinf: Flip everything over to -intel by default now.  Still install
  i810 driver just in case.

* Wed Aug 15 2007 Dave Airlie <airlied@redhat.com> 2.1.1-2
- intel-2.1.1-fix-texoffset-start.patch - shouldn't set texoffsetstart when not using EXA

* Tue Aug 14 2007 Dave Airlie <airlied@redhat.com> 2.1.1-1
- xf86-video-intel 2.1.1.

* Tue Jul 03 2007 Adam Jackson <ajax@redhat.com> 2.1.0-1
- xf86-video-intel 2.1.0.

* Mon Jun 18 2007 Adam Jackson <ajax@redhat.com> 2.0.0-5
- Update Requires and BuildRequires.

* Wed Jun 06 2007 Adam Jackson <ajax@redhat.com> 2.0.0-4
- Update to git master.  Many Xv and DVO fixes.  Adds support for 945GME,
  965GME, G33, Q33, and Q35 chips.

* Mon May 14 2007 Adam Jackson <ajax@redhat.com> 2.0.0-3
- intel-2.0-vblank-power-savings.patch: Disable vblank interrupts when no
  DRI clients are active, for better battery life.

* Tue May 01 2007 Adam Jackson <ajax@redhat.com> 2.0.0-2
- Rebuild for final RANDR 1.2 ABI.  Fixes segfault at startup. (#238575)

* Mon Apr 23 2007 Adam Jackson <ajax@redhat.com> 2.0.0-1
- xf86-video-intel 2.0.0.  Change the version number to match, why not.
- Add a Virtual provides for xorg-x11-drv-intel, since we should probably
  rename this at some point.

* Tue Apr 10 2007 Adam Jackson <ajax@redhat.com> 1.6.5-19
- i810.xinf: Move all 965 and 945 chips onto the new driver, as well as
  915GM.

* Thu Apr 05 2007 Adam Jackson <ajax@redhat.com> 1.6.5-18
- i810.xinf: More intel whitelisting (#214011, #234877)

* Wed Apr 04 2007 Adam Jackson <ajax@redhat.com> 1.6.5-17
- xf86-video-intel-1.9.94 (RC4).  Adds support for 965GM.
- i810.xinf: Point 965GM support at the intel driver since it's not present
  in old i810.

* Fri Mar 30 2007 Adam Jackson <ajax@redhat.com> 1.6.5-16
- xf86-video-intel-1.9.93 (RC3).

* Tue Mar 27 2007 Jeremy Katz <katzj@redhat.com> - 1.6.5-15
- fix typo with 945GM pci id from my laptop

* Thu Mar 22 2007 Adam Jackson <ajax@redhat.com> 1.6.5-14
- xf86-video-intel 1.9.92 (RC2).

* Mon Mar 05 2007 Adam Jackson <ajax@redhat.com> 1.6.5-13
- Updated modesetting driver to one that will actually work with a 1.3 server.

* Tue Feb 27 2007 Adam Jackson <ajax@redhat.com> 1.6.5-12
- Nuke %%with_dri, since the arch list exactly matched the ExclusiveArch list
- Remove ivch and ch7017 from the install since they aren't hooked up to the
  code anywhere
- Disown the module

* Tue Jan 30 2007 Jeremy Katz <katzj@redhat.com> - 1.6.5-11
- update modesetting driver to git snapshot from today

* Tue Nov 7 2006 Adam Jackson <ajackson@redhat.com> 1.6.5-10
- i965-xv-hang-fix.patch: Backport Xv hang fix for G965.

* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 1.6.5-9
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Fri Sep 22 2006 Adam Jackson <ajackson@redhat.com> 1.6.5-8.fc6
- Change 'Requires: kudzu >= foo' to 'Conflicts: kudzu < foo' since we don't
  actually require kudzu to run.

* Fri Sep 15 2006 Adam Jackson <ajackson@redhat.com> 1.6.5-7.fc6
- i810.xinf: Whitelist Apple 945GM machines and Aopen Mini PC onto intel(4)

* Tue Sep 12 2006 Adam Jackson <ajackson@redhat.com> 1.6.5-6.fc6
- i810-1.6.5-to-git-20060911.patch: Backport post-1.6.5 fixes from git.
- i810-match-server-sync-ranges.patch: Make a terrible heuristic in the
  driver match the corresponding terrible heuristic in the server.

* Mon Aug 28 2006 Adam Jackson <ajackson@redhat.com> 1.6.5-5.fc6
- intel-945gm-lfp-blacklist.patch: Tweak the Apple blacklist to (hopefully)
  correctly distinguish between Mac Mini and Macbook Pro.

* Mon Aug 21 2006 Adam Jackson <ajackson@redhat.com> 1.6.5-4.fc6
- i810.xinf: PCI IDs for i965.

* Thu Aug 17 2006 Adam Jackson <ajackson@redhat.com> 1.6.5-3.fc6
- i810.xinf: Uppercase PCI IDs.

* Fri Aug 10 2006 Adam Jackson <ajackson@redhat.com> 1.6.5-2.fc6
- Update i810 to 1.6.5, should fix DRI.
- Add kuzdu requires.
- i810.xinf: Start whitelisting devices over to intel.

* Wed Aug  9 2006 Adam Jackson <ajackson@redhat.com> 1.6.4-3.fc6
- intel-driver-rename.patch: Fix the driver name in more places so it'll,
  you know, load.

* Wed Aug  9 2006 Adam Jackson <ajackson@redhat.com> 1.6.4-2.fc6
- intel-945gm-lfp-blacklist.patch: At anholt's suggestion, remove the other
  LFP special casing in favor of the blacklist.

* Wed Aug  9 2006 Adam Jackson <ajackson@redhat.com> 1.6.4-1.fc6
- Admit defeat, kinda.  Package both i810 stable and modesetting drivers.
  The modesetting driver is installed as intel_drv.so instead of i810_drv.so,
  and is selected with Driver "intel" in xorg.conf.  Individual devices will
  whitelist over to "intel" until that branch gets merged into head.
- Update the stable branch driver to 1.6.4 from upstream, adds i965 support.
- intel-945gm-lfp-blacklist.patch: Blacklist LFP detection on machines where
  the BIOS is known to lie.

* Tue Aug  8 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-14.20060808modeset.fc6
- Today's snapshot: I2C bus creation fix.

* Wed Aug  2 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-13.20060717modeset.fc6
- intel-prune-by-edid-pixclock.patch: Honor the EDID-reported maximum pixel
  clock when computing the modes list.
- intel-virtual-sizing-bogon.patch: Don't interpret the size of the display
  in centimeters as the size of the display in pixels.

* Mon Jul 24 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-12.20060717modeset.fc6
- Disable spread-spectrum LVDS, various crash and hang fixes, saner output
  probing.

* Thu Jul 13 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-11.20060713modeset.fc6
- Update again for a mode comparison bugfix.

* Thu Jul 13 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-10.20060713modeset.fc6
- Update to today's git; crash fixes, better pre-915 support, slightly better
  autoconfigurability.

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> 1.6.0-9.20060707modeset.1.fc6
- rebuild

* Tue Jul 11 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-9.20060707modeset
- Fix Revision number to match naming policy.

* Tue Jul 11 2006 Kristian Høgsberg <krh@redhat.com> 1.6.0-8.modeset20060707
- Add back modesetting changes.

* Mon Jul 10 2006 Kristian Høgsberg <krh@redhat.com> 1.6.0-7
- Roll back modesetting changes and build for fc5 aiglx repo.

* Fri Jul  7 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-6.modeset20060707
- Snapshot of the git modesetting branch.

* Fri Jul  7 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-6
- Update i810.xinf to include entries for E7221 and 945GM.

* Fri Jun 23 2006 Mike A. Harris <mharris@redhat.com> 1.6.0-5
- Add with_dri macro to spec file, and conditionalize build time DRI support

* Fri May 26 2006 Mike A. Harris <mharris@redhat.com> 1.6.0-4
- Added "BuildRequires: libdrm >= 2.0-1" for (#192334), and updated sdk dep
  to pick up proto-devel as well.

* Tue May 23 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-3
- Rebuild for 7.1 ABI fix.

* Tue Apr 11 2006 Kristian Høgsberg <krh@redhat.com> 1.6.0-2
- Bump for fc5-bling build.

* Sun Apr 09 2006 Adam Jackson <ajackson@redhat.com> 1.6.0-1
- Update to 1.6.0 from 7.1RC1.

* Tue Apr 04 2006 Kristian Høgsberg <krh@redhat.com> 1.4.1.3-4.cvs20060322.1
- Add patch to add missing #include's, specifically assert.h.

* Wed Mar 22 2006 Kristian Høgsberg <krh@redhat.com> 1.4.1.3-4.cvs20060322
- Update to CVS snapshot of 20060322.

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> 1.4.1.3-3.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Sat Feb 04 2006 Mike A. Harris <mharris@redhat.com> 1.4.1.3-3
- Added 8086:2772 mapping to i810.xinf for bug (#178451)

* Fri Feb 03 2006 Mike A. Harris <mharris@redhat.com> 1.4.1.3-2
- Added 8086:2592 mapping to i810.xinf for bug (#172884)

* Wed Jan 18 2006 Mike A. Harris <mharris@redhat.com> 1.4.1.3-1
- Updated xorg-x11-drv-i810 to version 1.4.1.3 from X11R7.0

* Tue Dec 20 2005 Mike A. Harris <mharris@redhat.com> 1.4.1.2-1
- Updated xorg-x11-drv-i810 to version 1.4.1.2 from X11R7 RC4
- Removed 'x' suffix from manpage dirs to match RC4 upstream.

* Wed Nov 16 2005 Mike A. Harris <mharris@redhat.com> 1.4.1-1
- Updated xorg-x11-drv-i810 to version 1.4.1 from X11R7 RC2

* Fri Nov 04 2005 Mike A. Harris <mharris@redhat.com> 1.4.0.1-1
- Updated xorg-x11-drv-i810 to version 1.4.0.1 from X11R7 RC1
- Fix *.la file removal.
- Added 'devel' subpackage for XvMC .so
- Added 'BuildRequires: libXvMC-devel' for XvMC drivers.

* Mon Oct 03 2005 Mike A. Harris <mharris@redhat.com> 1.4.0-1
- Update BuildRoot to use Fedora Packaging Guidelines.
- Deglob file manifest.
- Limit "ExclusiveArch" to x86, x86_64, ia64

* Fri Sep 02 2005 Mike A. Harris <mharris@redhat.com> 1.4.0-0
- Initial spec file for i810 video driver generated automatically
  by my xorg-driverspecgen script.
